

import java.io.* ;


public class Life {
  static final int N      = 64 ;
  static final int NITER  = 50 ;

  static final String [] hosts = {"koum", "naos"} ;
  static final int NNODES = hosts.length ;

  public static void main(String args[]) {
    try {
      DataInputStream fromNode [] = new DataInputStream [NNODES] ;

      // Create a ring of channels

      Port R [] = new Port [NNODES] ;
      Port S [] = new Port [NNODES] ;

      for(int i = 0 ; i < NNODES ; i++) {
	R [i] = new Port() ;
	S [i] = new Port() ;
      }

      for(int i = 0 ; i < NNODES ; i++)
	Port.channel(R [i], S [(i + 1) % NNODES]) ;

      // Create the node processes.

      for(int i = 0 ; i < NNODES ; i++) {
	Port U = new Port() ;
	Port V = new Port() ;
	Port.channel(U, V) ;

	RPC.spawn("LifeWorker", hosts [i], V) ;

	// Send parameters to node

	U.sendInt(N) ;
	U.sendInt(NITER) ;

	U.sendInt(NNODES) ;
	U.sendInt(i) ;

	U.sendChan(R [i]) ;
	U.sendChan(S [i]) ;

	fromNode [i] = new DataInputStream(new PortInputStream(U)) ; 
      }

      /*  Handle output.  */

      for(int iter = 0 ; iter <= NITER ; iter++) {

	/*  Copy current state of board from nodes to a `.pgm' file.  */

	String fname = "life" + iter / 10 + iter % 10 + ".pgm" ;
	PrintStream out = new PrintStream(new FileOutputStream(fname)) ;

	out.println("P2") ;
	out.println("" + N + "  " + N) ;
	out.println("" + 1) ;

	for(int node_id = 0 ; node_id < NNODES ; node_id++) {
	  DataInputStream in = fromNode [node_id] ;

	  int blockLen = in.readInt() ;

	  for(int i = 0 ; i < blockLen ; i++) {
	    out.print("" + in.readInt() + "  ") ;
	    if(i % 20 == 19) out.println("") ;
	  }
	}
      }
    }
    catch(Exception e) {
      ;
    }
  }
}


